// Script assets have changed for v2.3.0 see
// https://help.yoyogames.com/hc/en-us/articles/360005277377 for more information
/*
//Used in place of a recipe when it does nothing for the time or ever
function Locked(){}
#region Food Generator
//Creates the list of recipies and text used in the craftroom
function Food_Generator_Recipies()
{
	text_and_recipies = ds_list_create()
	text = ds_list_create()
	ds_list_add(text, "Waste Rock: 5\n=\nFood: 1", "Nexus Energy: 1\n=\nFood: 1000", "Blue PS: 1\n=\nFood: 100", "Yellow PS: 1\n=\nFood: 200", "Pink PS: 1\n=\nFood: 400", "Nexus PS: 1\n=\nFood: 1600", "Alien Remains: 1\n=\nFood: 400")
	if global.ship_data.kitchen_teir >= 1
	{
		ds_list_add(text, "Biomass: 5 = Food: 100")
	}
	else
	{
		ds_list_add(text, "Locked")
	}
	if global.ship_data.kitchen_teir >= 2
	{
		ds_list_add(text, "Solid Biomass: 1 = Food: 100")
	}
	else
	{
		ds_list_add(text, "Locked")
	}
	recipies = ds_list_create()
	ds_list_add(recipies, Waste_Rock_to_Food, Nexus_Energy_to_Food, Blue_PS_to_Food, Yellow_PS_to_Food, Pink_PS_to_Food, Nexus_PS_to_Food, Alien_Remains_to_Food)
	if global.ship_data.kitchen_teir >= 1
	{
		ds_list_add(recipies, Biomass_to_Food)
	}
	else
	{
		ds_list_add(recipies, Locked)
	}
	if global.ship_data.kitchen_teir >= 2
	{
		ds_list_add(recipies, Solid_Biomass_to_Food)
	}
	else
	{
		ds_list_add(recipies, Locked)
	}
	ds_list_add(text_and_recipies, recipies, text)
	return text_and_recipies
}
//The following are the recipies
function Waste_Rock_to_Food()
{
	global.waste_rock -= 5
	global.food += 1
}
function Nexus_Energy_to_Food()
{
	global.nexus_energy -= 1
	global.food += 1000
}
function Blue_PS_to_Food()
{
	global.blue_power_slug -= 1
	global.food += 100
}
function Yellow_PS_to_Food()
{
	global.yellow_power_slug -= 1
	global.food += 200
}
function Pink_PS_to_Food()
{
	global.pink_power_slug -= 1
	global.food += 400
}
function Nexus_PS_to_Food()
{
	global.nexus_power_slug -= 1
	global.food += 1600
}
function Alien_Remains_to_Food()
{
	global.alien_remains -= 1
	global.food += 400
}
function Biomass_to_Food()
{
	global.biomass -= 5
	global.food += 100
}
function Solid_Biomass_to_Food()
{
	global.solid_biomass -= 1
	global.food += 100
}
#endregion
*/
//Used in place of a recipe when it does nothing for the time or ever
function Locked(){}
//All of these are nearly identical, so only first one will have comments
#region Food Generator
//Creates the list of recipies and text used in the craftroom
function Food_Generator_Recipies()
{
    //The lists
    text_and_recipies = ds_list_create()
    text = ds_list_create()
    recipies = ds_list_create()
    //Adding any recipe's text that does not require a teir
    ds_list_add(text, "Stone: 5\n=\nFood: 1", "Nexus Energy: 1\n=\nFood: 1000", "Blue PS: 1\n=\nFood: 100", "Yellow PS: 1\n=\nFood: 200", "Pink PS: 1\n=\nFood: 400", "Nexus PS: 1\n=\nFood: 1600", "Neutral Mass: 1\n=\nFood: 400")
    //Adding any recipe's text that does require a teir
    if global.ship_data >= 1
    {
        ds_list_add(text, "Biomass: 5 = Food: 100")
    }
    else
    {
        ds_list_add(text, "Locked")
    }
    if global.ship_data >= 2
    {
        ds_list_add(text, "Solid Biomass: 1 = Food: 100")
    }
    else
    {
        ds_list_add(text, "Locked")
    }
    //Adding any recipe functions that do not require a teir
    ds_list_add(recipies, Stone_to_Food, Nexus_Energy_to_Food, Blue_PS_to_Food, Yellow_PS_to_Food, Pink_PS_to_Food, Nexus_PS_to_Food, Alien_Remains_to_Food)
    //Adding recipe functions that do require a teir
    if global.ship_data >= 1
    {
        ds_list_add(recipies, Biomass_to_Food)
    }
    else
    {
        ds_list_add(recipies, Locked)
    }
    if global.ship_data >= 2
    {
        ds_list_add(recipies, Solid_Biomass_to_Food)
    }
    else
    {
        ds_list_add(recipies, Locked)
    }
    ds_list_add(text_and_recipies, recipies, text)
    return text_and_recipies
}
//The following are the recipies
//Function named what it does
function Stone_to_Food()
{
    //Lower a resource
    global.stone -= 5
    //Increase a resource
    global.food += 1
}
//These are just differing variables, not going over them
function Nexus_Energy_to_Food()
{
    global.nexus_energy -= 1
    global.food += 1000
}
function Blue_PS_to_Food()
{
    global.blue_power_slug -= 1
    global.food += 100
}
function Yellow_PS_to_Food()
{
    global.yellow_power_slug -= 1
    global.food += 200
}
function Pink_PS_to_Food()
{
    global.pink_power_slug -= 1
    global.food += 400
}
function Nexus_PS_to_Food()
{
    global.nexus_power_slug -= 1
    global.food += 1600
}
function Alien_Remains_to_Food()
{
    global.neutral_mass -= 100
    global.food += 400
}
function Biomass_to_Food()
{
    global.biomass -= 5
    global.food += 100
}
function Solid_Biomass_to_Food()
{
    global.solid_biomass -= 1
    global.food += 100
}
#endregion
#region Fizzionizer
function Fizzionizer_Recipies()
{
    text_and_recipies = ds_list_create()
    text = ds_list_create()
    if global.ship_data >= 1
    {
        ds_list_add(text, "Uranium: 2\n=\nUranium Fuel: 1", "Uranium Fuel: 10\nSteel Sheet: 1\n=\nUranium Fuel Rod: 1", "Uranium Fuel Rod: 1\n=\nBatteries: 100\nUranium Waste: 1", "Uranium Waste: 1\Uranium: 1n=\nPlutonium: 1", "Plutonium: 2\n=\nPlutonium Fuel: 1", "Plutonium Fuel: 5\nNexus Sheet: 1=\nPlutonium Fuel Rod: 2", "Plutonium Fuel Rod: 1\n=\nBatteries: 1000")
    }
    else
    {
        ds_list_add(text, "Locked", "Locked", "Locked", "Locked", "Locked", "Locked", "Locked")
    }
    if global.ship_data >= 2
    {
        ds_list_add(text, "Depleted Nexus Gem: 1\nUranium Fuel Rod: 2\n=\nNexus Gem: 1", "Depleted Nexus Gem: 10\nPlutonium Fuel Rod: 1\n=\nNexus Gem: 10")
    }
    else
    {
        ds_list_add(text, "Locked", "Locked")
    }
    recipies = ds_list_create()
    if global.ship_data >= 1
    {
        ds_list_add(recipies, Uranium_to_Uranium_Fuel, Uranium_fuel_to_Uranium_Fuel_Rod, Burn_Uranium_Rod, Waste_to_Plutonium, Plutonium_to_Plutonium_Fuel, Plutonium_to_Plutonium_Fuel_Rod, Burn_Plutonium_Rod)
    }
    else
    {
        ds_list_add(recipies, Locked, Locked, Locked, Locked, Locked, Locked, Locked)
    }
    if global.ship_data >= 2
    {
        ds_list_add(recipies, Recharge_Nexus_Gem_Uranium, Recharge_Nexus_Gem_Plutonium)
    }
    else
    {
        ds_list_add(recipies, Locked, Locked)
    }
    ds_list_add(text_and_recipies, recipies, text)
    return text_and_recipies
}
function Uranium_to_Uranium_Fuel()
{
    global.uranium -= 2
    global.uranium_fuel += 1
}
function Uranium_fuel_to_Uranium_Fuel_Rod()
{
    global.uranium_fuel -= 10
    global.steel_sheet -= 1
    global.uranium_fuel_rod += 1
}
function Recharge_Nexus_Gem_Uranium()
{
    global.depleted_nexus_gem -= 1
    global.uranium_fuel_rod -= 2
    global.nexus_gem += 1
}
function Burn_Uranium_Rod()
{
    global.uranium_fuel_rod -= 1
    global.battery += 100
    global.uranium_waste += 1
}
function Waste_to_Plutonium()
{
    global.uranium_waste -= 1
    global.uranium -= 1
    global.plutonium += 1
}
function Plutonium_to_Plutonium_Fuel()
{
    global.plutonium -= 2
    global.plutonium_fuel += 1
}
function Plutonium_to_Plutonium_Fuel_Rod()
{
    global.plutonium_fuel -= 5
    global.nexus_sheet -= 1
    global.plutonium_fuel_rod += 2
}
function Recharge_Nexus_Gem_Plutonium()
{
    global.depleted_nexus_gem -= 10
    global.plutonium_fuel_rod -= 2
    global.nexus_gem += 10
}
function Burn_Plutonium_Rod()
{
    global.plutonium_fuel_rod -= 1
    global.battery += 1000
}
#endregion
#region Smelter
function Smelter_Recipies()
{
    //Lists and arrays to use to create the functions and text
    text_and_recipies = ds_list_create()
    ores = [global.iron_ore, global.gold_ore, global.copper_ore]
    ingots = [global.iron_ingot, global.gold_ingot, global.copper_ingot]
    ore_names = ["Iron", "Gold", "Copper"]
    sheets = [global.iron_sheet, global.gold_sheet, global.copper_sheet, global.dense_hyperconductive_sheet, global.hyperconductive_sheet, global.steel_sheet, global.shielded_steel_sheet, global.strong_steel_sheet, global.nexus_sheet]
    ingot_name_string = ["Iron", "Gold", "Copper", "Dense Hyperconductive", "Hyperconductive", "Steel", "Shielded Steel", "Strong Steel", "Nexus"]
    text = ds_list_create()
    //For each string in ingot_name_string
    for(i = 0; i < (array_length(ore_names)); i += 1)
    {
        //Add the stirng with the respective type; Ex: Iron Ingot: 3 newline = newline Iron Sheet: 1
        ds_list_add(text, ore_names[i] + " Ore: 1\n=\n" + ore_names[i] + " Ingot: 1")
    }
    recipies = ds_list_create()
    for(i = -1; i < array_length(ore_names) - 1; i += 1)
    {
        var cpu = function()
        {
            ores[i] -= 1
            ingots[i] += 1
        }
        ds_list_add(recipies, cpu)
        show_debug_message(recipies[| i])
    }
    if global.ship_data >= 1
    {
        slugs = [global.blue_power_slug, global.yellow_power_slug, global.pink_power_slug, global.nexus_power_slug]
        amount = [100, 200, 400, 1600]
        names = ["Blue PS", "Yellow PS", "Pink PS", "Nexus PS"]
        for(i = -1; i < (array_length(slugs) - 1); i += 1)
        {
            var cpu = function()
            {
                ores = ores = [global.copper_ore, global.iron_ore, global.gold_ore, global.coal, global.bauxite]
                slugs[i] -= 1
                ores[irandom(array_length(ores))] += amount[i]
            }
            ds_list_add(text, names[i] + "\n=\nRandom Ore: " + string(amount[i]))
            ds_list_add(recipies, cpu)
            
        }
    }
    else
    {
        ds_list_add(text, "Locked", "Locked", "Locked", "Locked")
        ds_list_add(recipies, Locked, Locked, Locked, Locked)
    }
    if global.ship_data >= 2
    {
        nexus = [global.nexus_energy, global.depleted_nexus_gem]
        names = ["Nexus Energy", "Depleted Nexus Gem"]
        amount = [2, 5]
        for(i = -1; i < array_length(nexus) - 1; i += 1)
        {
            var cpu = function()
            {
                nexus[i] -= 1
                global.nexus_ingot += amount[i]
            }
            ds_list_add(text, names[i] + ": 1\n=\n Nexus Ingot: " + amount[i])
        }
	}
	else
	{
		ds_list_add(text, "Locked", "Locked")
		ds_list_add(recipies, Locked, Locked)
	}
    ds_list_add(text_and_recipies, recipies, text)
    return text_and_recipies
}
function Copper_to_Copper_Ingot()
{
    global.copper_ore -= 1
    global.copper_ingot += 1
}
function Iron_to_Iron_Ingot()
{
    global.iron_ore -= 1
    global.iron_ingot += 1
}
function Gold_to_Gold_Ingot()
{
    global.gold_ore -= 1
    global.gold_ingot += 1
}
function Nexus_Energy_to_Nexus_Ingot()
{
    global.nexus_energy -= 1
    global.nexus_ingot += 2
}
function Depleted_Nexus_Gem_to_Nexus_Ingot()
{
    global.depleted_nexus_gem -= 1
    global.nexus_ingot += 5
}
function Blue_PS_to_Ore()
{
    ores = [global.copper_ore, global.iron_ore, global.gold_ore, global.coal]
    global.blue_power_slug -= 1
    ores[irandom(array_length(ores))] += 100
}
function Yellow_PS_to_Ore()
{
    ores = [global.copper_ore, global.iron_ore, global.gold_ore, global.coal]
    global.yellow_power_slug -= 1
    ores[irandom(array_length(ores))] += 200
}
function Pink_PS_to_Ore()
{
    ores = [global.copper_ore, global.iron_ore, global.gold_ore, global.coal]
    global.pink_power_slug -= 1
    ores[irandom(array_length(ores))] += 400
}
function Nexus_PS_to_Ore()
{
    ores = [global.copper_ore, global.iron_ore, global.gold_ore, global.coal]
    global.nexus_power_slug -= 1
    ores[irandom(array_length(ores))] += 1600
}
#endregion
#region Foundary
function Foundary_Recipies()
{
    //Lists and arrays to use to create the functions and text
    text_and_recipies = ds_list_create()
    ingredient1 = [global.bauxite, global.copper_ore, global.copper_ingot, global.hyperconductive_ingot, global.iron_ore, global.aluminum_ingot, global.gold_ingot]
    ingredient2 = [global.copper_ore, global.gold_ore, global.gold_ingot, global.hyperconductive_ingot, global.coal, global.steel_ingot, global.steel_ingot]
    result = [global.aluminum_ingot, global.hyperconductive_ingot, global.hyperconductive_ingot, global.dense_hyperconductive_ingot, global.steel_ingot, global.strong_steel_ingot, global.shielded_steel_ingot]
    ingredient1_string = ["Bauxite", "Copper Ore", "Copper Ingot", "Hyperconductive\nIngot", "Iron Ore", "Aluminum Ingot", "Gold Ingot"]
    ingredient2_string = ["Copper Ore", "Gold Ore", "Gold Ingot", "Hyperconductive\nIngot", "Coal", "Steel Ingot", "Steel Ingot"]
    result_string = ["Aluminum", "Hyperconductive\n", "Hyperconductive\n", "Dense Hyperconductive\n", "Steel", "Strong Steel\n", "Shielded Steel\n"]
    text = ds_list_create()
    //For each string in ingot_name_string
    for(i = 0; i < array_length(ingredient1_string); i += 1)
    {
        //Add the stirng with the respective type; Ex: Iron Ingot: 3 newline = newline Iron Sheet: 1
        ds_list_add(text, ingredient1_string[i] + "\n" + ingredient2_string[i] + "\n=\n" + result_string[i] + " Ingot: 1")
    }
    recipies = ds_list_create()
    for(i = -1; i < array_length(ingredient1) - 1; i += 1)
    {
        var cpu = function()
        {
            ingredient1[i] -= 1
            ingredient2[i] -= 1
            result[i] += 1
        }
        ds_list_add(recipies, cpu)
    }
	if global.ship_data >= 2
	{
		ds_list_add(text, "Dense HC Ingot: 10\nStrong Steel Ingot: 10\nShielded Steel Ingot: 10\n=\nNexus Ingot: 1", "Dense HC Ingot: 100\nStrong Steel Ingot: 100\nShielded Steel Ingot: 100\n=\nDepleted Nexus Gem: 1")
		ds_list_add(recipies, Artificial_Nexus_Ingot, Artificial_Depleted_Nexus_Gem)
	}
	else
	{
		ds_list_add(text, "Locked", "Locked")
		ds_list_add(recipies, Locked, Locked)
	}
	ds_list_add(text_and_recipies, recipies, text)
    return text_and_recipies
}
function Aluminum_Ingot()
{
    global.bauxite -= 1
    global.copper_ore -= 1
    global.aluminum_ingot += 1
}
function Hyperconductive_Ingot()
{
    global.copper_ore -= 1
    global.gold_ore -= 1
    global.hyperconductive_ingot += 1
}
function Hyperconductive_Ingot_Merged()
{
    global.copper_ingot -= 1
    global.gold_ingot -= 1
    global.hyperconductive_ingot += 1
}
function Dense_Hyperconductive_Ingot()
{
    global.hyperconductive_ingot -= 2
    global.dense_hyperconductive_ingot += 1
}
function Steel_Ingot()
{
    global.iron_ore -= 1
    global.coal -= 1
    global.steel_ingot += 1
}
function Strong_Steel_Ingot()
{
    global.aluminum_ingot -= 1
    global.steel_ingot -= 1
    global.strong_steel_ingot += 1
}
function Sheilded_Steel_Ingot()
{
    global.gold_ingot -= 1
    global.steel_ingot -= 1
    global.shielded_steel_ingot += 1
}
function Artificial_Nexus_Ingot()
{
    global.dense_hyperconductive_ingot -= 10
    global.strong_steel_ingot -= 10
    global.shielded_steel_ingot -= 10
    global.nexus_ingot += 1
}
function Artificial_Depleted_Nexus_Gem()
{
    global.dense_hyperconductive_ingot -= 100
    global.strong_steel_ingot -= 100
    global.shielded_steel_ingot -= 100
    global.depleted_nexus_gem += 1
}
#endregion
#region Motherboard Producer
function Motherboard_Producer_Recipies()
{
    //Lists and arrays to use to create the functions and text
    text_and_recipies = ds_list_create()
    ingredient1 = [global.iron_wire, global.steel_wire, global.strong_steel_wire, global.shielded_steel_wire, global.copper_wire, global.gold_wire, global.hyperconductive_wire, global.dense_hyperconductive_wire, global.nexus_wire]
    ingredient1_string = ["Iron", "Steel", "Strong Steel", "Shielded Steel", "Copper", "Gold", "Hyperconductive", "Dense Hyperconductive", "Nexus"]
    text = ds_list_create()
    //For each string in ingot_name_string
    for(i = 0; i < array_length(ingredient1_string); i += 1)
    {
        //Add the stirng with the respective type; Ex: Iron Ingot: 3 newline = newline Iron Sheet: 1
        ds_list_add(text, ingredient1_string[i] + " Wire: 10\n=\n" + "Motherboard: " + string(i))
    }
    recipies = ds_list_create()
    for(i = -1; i < array_length(ingredient1) - 1; i += 1)
    {
        var cpu = function()
        {
            ingredient1[i] -= 10
            global.plastic -= 2
            global.motherboard += i + 1
        }
        ds_list_add(recipies, cpu)
    }
    ds_list_add(text_and_recipies, recipies, text)
    return text_and_recipies
}
function Motherboard_Copper()
{
    global.plastic -= 2
    global.copper_wire -= 10
    global.motherboard += 1
}
function Motherboard_Gold()
{
    global.plastic -= 2
    global.gold_wire -= 10
    global.motherboard += 2
}
function Motherboard_Hyperconductive()
{
    global.plastic -= 2
    global.hyperconductive_wire -= 10
    global.motherboard += 4
}
function Motherboard_Dense_Hyperconductive()
{
    global.plastic -= 2
    global.dense_hyperconductive_wire -= 10
    global.motherboard += 8
}
function Motherboard_Nexus()
{
    global.plastic -= 2
    global.nexus_wire -= 10
    global.motherboard += 800
}
function One_Motherboard_Powered_Search()
{
    global.alien_remains -= 2
    global.motherboard -= 1
    if irandom(10) == 10
    {
        global.depleted_nexus_gem += 1
    }
    else
    {
        global.alien_remains += 1
    }
}
function Two_Motherboard_Powered_Search()
{
    global.alien_remains -= 2
    global.motherboard -= 2
    if irandom(10) >= 8
    {
        global.depleted_nexus_gem += 1
    }
    else
    {
        global.alien_remains += 1
    }
}
function Four_Motherboard_Powered_Search()
{
    global.alien_remains -= 2
    global.motherboard -= 4
    if irandom(10) >= 5
    {
        global.depleted_nexus_gem += 1
    }
    else
    {
        global.alien_remains += 1
    }
}
function Eight_Motherboard_Powered_Search()
{
    global.alien_remains -= 2
    global.motherboard -= 8
    global.depleted_nexus_gem += 1
}
#endregion
#region Oil Processor
function Oil_Processor_Recipies()
{
    text_and_recipies = ds_list_create()
    text = ds_list_create()
    ds_list_add(text, "Oil: 1\n=\nResin: 1\nPlastic: 1", "Resin: 1\n=\nPlastic: 1", "Fuel: 1\nRubber: 1\n=\nPlastic: 4", "Oil: 1\n=\nResin: 1\nRubber: 1", "Resin: 1\n=\nRubber: 2", "Plastic: 1\nFuel: 1\n=\nRubber: 2", "Oil: 1\n=\nFuel: 2", "Resin: 1\n=\nFuel: 1", "Fuel: 1\n=\nBatteries: 10")
    recipies = ds_list_create()
    ds_list_add(recipies, Plastic_Oil, Plastic_Resin, Plastic_Recycle, Rubber_Oil, Rubber_Resin, Rubber_Recycle(), Fuel_Oil(), Fuel_Resin(), Burn_Fuel())
    ds_list_add(text_and_recipies, recipies, text)
    return text_and_recipies
}
function Plastic_Oil()
{
    global.oil -= 1
    global.resin += 1
    global.plastic += 1
}
function Plastic_Resin()
{
    global.resin -= 1
    global.plastic += 1
}
function Plastic_Recycle()
{
    global.rubber -= 1
    global.fuel -= 1
    global.plastic += 4
}
function Rubber_Oil()
{
    global.oil -= 1
    global.resin += 1
}
function Rubber_Resin()
{
    global.resin -= 1
    global.rubber += 2
}
function Rubber_Recycle()
{
    global.plastic -= 1
    global.fuel -= 1
    global.rubber += 2
}
function Fuel_Oil()
{
    global.oil -= 1
    global.resin += 1
    global.fuel += 2
}
function Fuel_Resin()
{
    global.resin -= 1
    global.fuel += 1
}
function Burn_Fuel()
{
    global.fuel -= 1
    global.battery += 10
}
#endregion
//This one is differing to save lines
#region Sheet Manufacturer
function Sheet_Manufacturer_Recipies()
{
    //Lists and arrays to use to create the functions and text
    text_and_recipies = ds_list_create()
    ingots = [global.iron_ingot, global.gold_ingot, global.copper_ingot, global.dense_hyperconductive_ingot, global.hyperconductive_ingot, global.steel_ingot, global.shielded_steel_ingot, global.strong_steel_ingot, global.nexus_ingot]
    sheets = [global.iron_sheet, global.gold_sheet, global.copper_sheet, global.dense_hyperconductive_sheet, global.hyperconductive_sheet, global.steel_sheet, global.shielded_steel_sheet, global.strong_steel_sheet, global.nexus_sheet]
    ingot_name_string = ["Iron", "Gold", "Copper", "Dense Hyperconductive", "Hyperconductive", "Steel", "Shielded Steel", "Strong Steel", "Nexus"]
    text = ds_list_create()
    //For each string in ingot_name_string
    for(i = 0; i < array_length(ingot_name_string); i += 1)
    {
        //Add the stirng with the respective type; Ex: Iron Ingot: 3 newline = newline Iron Sheet: 1
        ds_list_add(text, ingot_name_string[i] + " Ingot: 3\n=\n" + ingot_name_string[i] + "Sheet: 1")
    }
    recipies = ds_list_create()
    for(i = -1; i < array_length(ingot_name_string) - 1; i += 1)
    {
        var cpu = function()
        {
            ingots[i] -= 3
            sheets[i] += 1
        }
        ds_list_add(recipies, cpu)
        show_debug_message(recipies[| i])
    }
    ds_list_add(text_and_recipies, recipies, text)
    return text_and_recipies
}
#endregion
#region Wire Manufacturer
function Wire_Manufacturer_Recipies()
{
    //Lists and arrays to use to create the functions and text
    text_and_recipies = ds_list_create()
    ingots = [global.iron_ingot, global.gold_ingot, global.copper_ingot, global.dense_hyperconductive_ingot, global.hyperconductive_ingot, global.steel_ingot, global.shielded_steel_ingot, global.strong_steel_ingot, global.nexus_ingot]
    sheets = [global.iron_wire, global.gold_wire, global.copper_wire, global.dense_hyperconductive_wire, global.hyperconductive_wire, global.steel_wire, global.shielded_steel_wire, global.strong_steel_wire, global.nexus_wire]
    ingot_name_string = ["Iron", "Gold", "Copper", "Dense Hyperconductive", "Hyperconductive", "Steel", "Shielded Steel", "Strong Steel", "Nexus"]
    text = ds_list_create()
    //For each string in ingot_name_string
    for(i = 0; i < array_length(ingot_name_string); i += 1)
    {
        //Add the stirng with the respective type; Ex: Iron Ingot: 3 newline = newline Iron Sheet: 1
        ds_list_add(text, ingot_name_string[i] + " Ingot: 1\n=\n" + ingot_name_string[i] + "Wire: 2")
    }
    recipies = ds_list_create()
    for(i = -1; i < array_length(ingot_name_string) - 1; i += 1)
    {
        var cpu = function()
        {
            ingots[i] -= 3
            sheets[i] += 1
        }
        ds_list_add(recipies, cpu)
    }
    ds_list_add(text_and_recipies, recipies, text)
    return text_and_recipies
}
#endregion
#region Piping Assembler
function Piping_Assembler_Recipies()
{
    //Lists and arrays to use to create the functions and text
    text_and_recipies = ds_list_create()
    ingots = [global.iron_ingot, global.gold_ingot, global.copper_ingot, global.dense_hyperconductive_ingot, global.hyperconductive_ingot, global.steel_ingot, global.shielded_steel_ingot, global.strong_steel_ingot, global.nexus_ingot]
    sheets = [global.iron_pipe, global.gold_pipe, global.copper_pipe, global.dense_hyperconductive_pipe, global.hyperconductive_pipe, global.steel_pipe, global.shielded_steel_pipe, global.strong_steel_pipe, global.nexus_pipe]
    ingot_name_string = ["Iron", "Gold", "Copper", "Dense Hyperconductive", "Hyperconductive", "Steel", "Shielded Steel", "Strong Steel", "Nexus"]
    text = ds_list_create()
    //For each string in ingot_name_string
    for(i = 0; i < array_length(ingot_name_string); i += 1)
    {
        //Add the stirng with the respective type; Ex: Iron Ingot: 3 newline = newline Iron Sheet: 1
        ds_list_add(text, ingot_name_string[i] + " Ingot: 2\n=\n" + ingot_name_string[i] + "Pipe: 1")
    }
    recipies = ds_list_create()
    for(i = -1; i < array_length(ingots) - 1; i += 1)
    {
        var cpu = function()
        {
            ingots[i] -= 2
            sheets[i] += 1
        }
        ds_list_add(recipies, cpu)
    }
    ds_list_add(text_and_recipies, recipies, text)
    return text_and_recipies
}
#endregion
#region Nexus Gem Harvester
function Nexus_Gem_Harvester_Recipies()
{
    text_and_recipies = ds_list_create()
    ingots = [global.nexus_energy, global.depleted_nexus_gem, global.nexus_ingot]
    ingot_name_string = ["Nexus Energy", "Depleted Nexus Gem", "Nexus Ingot"]
	amount = [1000, 500, 100]
    text = ds_list_create()
	ds_list_add(text, "Nexus_Gem: 1\n=\nNexus Energy: 1\nDepleted\nNexus Gem:1")
    //For each string in ingot_name_string
    for(i = 0; i < array_length(ingot_name_string); i += 1)
    {
        //Add the stirng with the respective type; Ex: Iron Ingot: 3 newline = newline Iron Sheet: 1
        ds_list_add(text, ingot_name_string[i] + ":1\n=\n" + "Random \nResource: " + string(amount[i]))
		ds_list_add(text, ingot_name_string[i] + ":1\n=\n" + "Random LS \nResource: " + string(amount[i]))
    }
    recipies = ds_list_create()
	var cpu = function()
	{
		global.nexus_gem -= 1
		global.nexus_energy += 1
		global.depleted_nexus_gem += 1
	}
	ds_list_add(recipies, cpu)
    for(i = -1; i < array_length(ingots) - 1; i += 1)
    {
        var cpu = function()
        {
			ores = [global.copper_ore, global.iron_ore, global.gold_ore, global.coal, global.bauxite, global.oil, global.uranium]
            ingots[i] -= 1
			index = irandom(array_length(ores) - 1)
            ores[index] += amount[i]
        }
        ds_list_add(recipies, cpu)
		var cpu = function()
        {
			ores = [global.copper_ore, global.iron_ore, global.gold_ore, global.coal, global.bauxite, global.oil, global.uranium]
            ingots[i] -= 1
			index = irandom(array_length(ores) - 1)
            ores[index] += amount[i]
        }
        ds_list_add(recipies, cpu)
    }
	ds_list_add(recipies, Nexus_Ingot_to_Depleted_Nexus_Gem, Nexus_Gem_to_Depleted_Nexus_Gem)
	ds_list_add(text, "Nexus Ingot: 20 \n=\nDepleted\nNexus Gem: 1", "Nexus Gem: 1 \n=\nDepleted\nNexus Gem: 2")
    ds_list_add(text_and_recipies, recipies, text)
    return text_and_recipies
}
function Nexus_Gem_to_Nexus_Energy()
{
    global.nexus_gem -= 1
    global.nexus_energy += 1
    global.depleted_nexus_gem += 1
}
function Nexus_Energy_to_Random_Resource()
{
    ores = [global.copper_ore, global.iron_ore, global.gold_ore, global.coal, global.bauxite, global.oil, global.uranium]
    global.nexus_energy -= 1
    ores[irandom(array_length(ores))] += 1000
}
function Nexus_Energy_to_Random_LS_Resource()
{
    ores = [global.food, global.oxygen, global.battery, global.water]
    global.nexus_energy -= 1
    ores[irandom(array_length(ores))] += 1000
}
function Depleted_Nexus_Gem_to_Random_Resource()
{
    ores = [global.copper_ore, global.iron_ore, global.gold_ore, global.coal, global.bauxite, global.oil, global.uranium]
    global.depleted_nexus_gem -= 1
    ores[irandom(array_length(ores))] += 500
}
function Depleted_Nexus_Gem_to_Random_LS_Resource()
{
    ores = [global.food, global.oxygen, global.battery, global.water]
    global.depleted_nexus_gem -= 1
    ores[irandom(array_length(ores))] += 500
}
function Nexus_Ingot_to_Random_Resource()
{
    ores = [global.copper_ore, global.iron_ore, global.gold_ore, global.coal, global.bauxite, global.oil, global.uranium]
    global.nexus_ingot -= 1
    ores[irandom(array_length(ores))] += 100
}
function Nexus_Ingot_to_Random_LS_Resource()
{
    ores = [global.food, global.oxygen, global.battery, global.water]
    global.nexus_ingot -= 1
    ores[irandom(array_length(ores))] += 100
}
function Nexus_Ingot_to_Depleted_Nexus_Gem()
{
    global.nexus_ingot -= 20
    global.depleted_nexus_gem += 1
}
function Nexus_Gem_to_Depleted_Nexus_Gem()
{
    global.nexus_gem -= 1
    global.depleted_nexus_gem += 2
}
#endregion
#region Fusionizer
function Fusionizer_Recipies()
{
    text_and_recipies = ds_list_create()
    text = ds_list_create()
    if global.ship_data >= 1
    {
        ds_list_add(text, "Water: 1\n=\nHydrogen: 1\nOxygen: 2", "Hydrogen: 1\n=\nNeutral Mass: 1", "Oxygen: 1\n=\nNeutral Mass: 8", "Copper Ore: 1\n=\nNeutral Mass: 29", "Bauxite: 1\n=\nNeutral Mass: 13", "Gold Ore: 1\n=\nNeutral Mass: 79", "Neutral Mass: 1000\n=\nNuclear Pasta: 1", "Nuclear Pasta: 1\n=\nBatteries: 10000")
    }
    else
    {
        ds_list_add(text, "Locked", "Locked", "Locked", "Locked", "Locked", "Locked", "Locked", "Locked")
    }
    if global.ship_data >= 2
    {
        ds_list_add(text, "Nuclear Pasta: 1\nDepleted Nexus Gem: 20\n=\nNexus Gem: 20")
    }
    else
    {
        ds_list_add(text, "Locked")
    }
    recipies = ds_list_create()
    if global.ship_data >= 1
    {
        ds_list_add(recipies, Water_to_Hydrogen, Hydrogen_to_Neutral_Mass, Oxygen_to_Neutral_Mass, Copper_Ore_to_Neutral_Mass, Bauxite_to_Neutral_Mass, Gold_Ore_to_Neutral_Mass, Nuclear_Pasta, Burn_Nuclear_Pasta)
    }
    else
    {
        ds_list_add(recipies, Locked, Locked, Locked, Locked, Locked, Locked, Locked, Locked)
    }
    if global.ship_data >= 2
    {
        ds_list_add(recipies, Recharge_Nexus_Gem_Nuclear_Pasta)
    }
    else
    {
        ds_list_add(recipies, Locked)
    }
    ds_list_add(text_and_recipies, recipies, text)
    return text_and_recipies
}
function Water_to_Hydrogen()
{
    global.water -= 1
    global.oxygen += 2
    global.hydrogen += 1
}
function Hydrogen_to_Neutral_Mass()
{
    global.hydrogen -= 1
    global.neutral_mass += 1
}
function Oxygen_to_Neutral_Mass()
{
    global.oxygen -= 1
    global.neutral_mass += 8
}
function Copper_Ore_to_Neutral_Mass()
{
    global.copper_ore -= 1
    global.neutral_mass += 29
}
function Bauxite_to_Neutral_Mass()
{
    global.bauxite -= 1
    global.neutral_mass += 13
}
function Gold_Ore_to_Neutral_Mass()
{
    global.gold_ore -= 1
    global.neutral_mass += 79
}
function Nuclear_Pasta()
{
    global.neutral_mass -= 1000
    global.nuclear_pasta += 1
}
function Recharge_Nexus_Gem_Nuclear_Pasta()
{
    global.depleted_nexus_gem -= 20
    global.nuclear_pasta -= 1
    global.nexus_gem += 20
}
function Burn_Nuclear_Pasta()
{
    global.nuclear_pasta -= 1
    global.battery += 10000
}
#endregion
#region Biomass Unifier
function Biomass_Unifier_Recipies()
{
    text_and_recipies = ds_list_create()
    text = ds_list_create()
    ds_list_add(text, "Food: 2\n=\nBiomass: 1", "Oxygen: 2\n=\nBiomass: 1", "Hydrogen: 2\n=\nBiomass: 1", "Biomass: 2\n=\nSolid Biomass: 1", "Soild Biomass: 1\n=\nBiomass: 1", "Soild Biomass: 1\n=\nOxygen: 10", "Biomass: 1\n=\nBattery: 10", "Soild Biomass: 1\n=\nBattery: 20", "Soild Biomass: 1\n=\nHydrogen: 10")
    recipies = ds_list_create()
    ds_list_add(recipies, Food_to_Biomass, Oxygen_to_Biomass, Hydrogen_to_Biomass, Biomass_to_Solid_Biomass, Soild_Biomass_to_Biomass, Biomass_to_Liquid_Biomass, Burn_Biomass(), Burn_Soild_Biomass(), Burn_Liquid_Biomass())
    ds_list_add(text_and_recipies, recipies, text)
    return text_and_recipies
}
function Food_to_Biomass()
{
    global.food -= 2
    global.biomass += 1
}
function Oxygen_to_Biomass()
{
    global.oxygen -= 2
    global.biomass += 1
}
function Hydrogen_to_Biomass()
{
    global.hydrogen -= 2
    global.biomass += 1
}
function Biomass_to_Solid_Biomass()
{
    global.biomass -= 2
    global.solid_biomass += 1
}
function Soild_Biomass_to_Biomass()
{
    global.solid_biomass -= 1
    global.biomass += 1
}
function Biomass_to_Liquid_Biomass()
{
    global.solid_biomass -= 2
    global.oxygen += 10
}
function Burn_Biomass()
{
    global.biomass -= 1
    global.battery += 10
}
function Burn_Soild_Biomass()
{
    global.soild_biomass -= 1
    global.battery += 20
}
function Burn_Liquid_Biomass()
{
    global.solid_biomass -= 1
    global.hydrogen += 10
}
#endregion
#region Computer Manufactorer
function Computer_Assembler_Recipies()
{
    //Lists and arrays to use to create the functions and text
    text_and_recipies = ds_list_create()
    ingredient1 = [global.iron_wire, global.shielded_steel_wire, global.strong_steel_wire, global.steel_wire, global.copper_wire, global.gold_wire, global.hyperconductive_wire, global.dense_hyperconductive_wire, global.nexus_ingot]
    ingredient2 = [global.gold_sheet, global.copper_sheet, global.hyperconductive_sheet, global.dense_hyperconductive_sheet, global.iron_sheet, global.steel_sheet, global.shielded_steel_sheet, global.strong_steel_sheet, global.nexus_sheet]
    ingredient1_string = ["Iron", "Shielded Steel\n", "Strong Steel\n", "Steel", "Copper", "Gold", "Hyperconductive\n", "Dense Hyperconductive\n", "Nexus"]
    ingredient2_string = ["Iron", "Gold", "Copper", "Dense Hyperconductive\n", "Hyperconductive\n", "Steel", "Shielded Steel\n", "Strong Steel\n", "Nexus"]
    text = ds_list_create()
    //For each string in ingot_name_string
    for(i = 0; i < array_length(ingredient1_string); i += 1)
    {
        //Add the stirng with the respective type; Ex: Iron Ingot: 3 newline = newline Iron Sheet: 1
        ds_list_add(text, ingredient1_string[i] + " Wire: 20\n" + ingredient2_string[i] + "Sheet: 10\n=\nComputer: " + string(i + 1))
    }
    recipies = ds_list_create()
    for(i = -1; i < array_length(ingredient1) - 1; i += 1)
    {
        var cpu = function()
        {
            ingredient1[i] -= 20
            ingredient2[i] -= 10
            global.motherboard -= (i + 1)
            global.computer += (i + 1)
        }
        ds_list_add(recipies, cpu)
        show_debug_message(i)
    }
    ds_list_add(text_and_recipies, recipies, text)
    return text_and_recipies
}
#endregion
#region Engine Manufactorer
function Engine_Assembler_Recipies()
{
    //Lists and arrays to use to create the functions and text
    text_and_recipies = ds_list_create()
    ingredient1 = [global.iron_wire, global.shielded_steel_wire, global.strong_steel_wire, global.steel_wire, global.copper_wire, global.gold_wire, global.hyperconductive_wire, global.dense_hyperconductive_wire, global.nexus_ingot]
    ingredient2 = [global.gold_sheet, global.copper_sheet, global.hyperconductive_sheet, global.dense_hyperconductive_sheet, global.iron_sheet, global.steel_sheet, global.shielded_steel_sheet, global.strong_steel_sheet, global.nexus_sheet]
    ingredient3 = [global.iron_pipe, global.steel_pipe, global.shielded_steel_pipe, global.strong_steel_pipe, global.gold_pipe, global.copper_pipe, global.hyperconductive_pipe, global.dense_hyperconductive_pipe, global.nexus_pipe]
    ingredient1_string = ["Iron", "Shielded Steel\n", "Strong Steel\n", "Steel", "Copper", "Gold", "Hyperconductive\n", "Dense Hyperconductive\n", "Nexus"]
    ingredient2_string = ["Iron", "Gold", "Copper", "Dense Hyperconductive\n", "Hyperconductive\n", "Steel", "Shielded Steel\n", "Strong Steel\n", "Nexus"]
    ingredient3_string = ["Iron", "Steel", "Shielded Steel\n", "Strong Steel\n", "Gold", "Copper", "Hyperconductive\n", "Dense Hyperconductive\n", "Nexus"]
    text = ds_list_create()
    //For each string in ingot_name_string
    for(i = 0; i < array_length(ingredient1_string); i += 1)
    {
        //Add the stirng with the respective type; Ex: Iron Ingot: 3 newline = newline Iron Sheet: 1
        ds_list_add(text, ingredient1_string[i] + " Wire: 20\n" + ingredient2_string[i] + " Sheet: 30\n" + ingredient3_string[i] + " Pipe: 30\n=\nEngine: " + string(i))
    }
    recipies = ds_list_create()
    for(i = -1; i < array_length(ingredient1) - 1; i += 1)
    {
        var cpu = function()
        {
            ingredient1[i] -= 20
            ingredient2[i] -= 30
            ingredient3[i] -= 30
            global.engine += i
        }
        ds_list_add(recipies, cpu)
    }
    ds_list_add(text_and_recipies, recipies, text)
    return text_and_recipies
}
#endregion